Index: src/sas/qtgui/BoxSum.py
===================================================================
--- src/sas/qtgui/BoxSum.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
+++ src/sas/qtgui/BoxSum.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
@@ -0,0 +1,42 @@
+"""
+Allows users to modify the box slicer parameters.
+"""
+from PyQt4 import QtGui
+from PyQt4 import QtCore
+
+# Local UI
+from sas.qtgui.UI.BoxSumUI import Ui_BoxSumUI
+
+class BoxSum(QtGui.QDialog, Ui_BoxSumUI):
+    apply_signal = QtCore.pyqtSignal(tuple, str)
+    def __init__(self, parent=None, model=None):
+        super(BoxSum, self).__init__()
+
+        self.setupUi(self)
+        assert isinstance(model, QtGui.QStandardItemModel)
+
+        self.txtBoxHeight.setValidator(QtGui.QDoubleValidator())
+        self.txtBoxWidth.setValidator(QtGui.QDoubleValidator())
+        self.txtCenterX.setValidator(QtGui.QDoubleValidator())
+        self.txtCenterY.setValidator(QtGui.QDoubleValidator())
+
+        self.model = model
+        self.mapper = QtGui.QDataWidgetMapper()
+        self.mapper.setModel(self.model)
+
+        # Map model items onto widget controls
+        self.mapper.addMapping(self.txtBoxHeight, 0)
+        self.mapper.addMapping(self.txtBoxWidth, 1)
+        self.mapper.addMapping(self.txtCenterX, 2)
+        self.mapper.addMapping(self.txtCenterY, 3)
+        self.mapper.addMapping(self.lblAvg, 4, "text")
+        self.mapper.addMapping(self.lblAvgErr, 5, "text")
+        self.mapper.addMapping(self.lblSum, 6, "text")
+        self.mapper.addMapping(self.lblSumErr, 7, "text")
+        self.mapper.addMapping(self.lblNumPoints, 8, "text")
+
+        # Populate the widgets with data from the first column
+        self.mapper.toFirst()
+
+        self.setFixedSize(self.minimumSizeHint())
+
Index: src/sas/qtgui/ColorMap.py
===================================================================
--- src/sas/qtgui/ColorMap.py	(revision 5d89f43266c67cb96a7bf395800ce4cce896c9f8)
+++ src/sas/qtgui/ColorMap.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
@@ -111,11 +111,4 @@
         self.canvas.draw()
 
-    def onApply(self):
-        """
-        Respond to the Apply button click.
-        Send a signal to the plotter with vmin/vmax/cmap for chart update
-        """
-        self.apply_signal.emit(self.norm(), self.cmap())
-
     def initDetectorData(self):
         """
@@ -214,5 +207,5 @@
                                             norm=self._norm,
                                             orientation='horizontal')
-        self.cb.set_label('Color map range')
+        self.cb.set_label('Detector Colors')
 
     def onColorMapReversed(self, isChecked):
Index: src/sas/qtgui/DataExplorer.py
===================================================================
--- src/sas/qtgui/DataExplorer.py	(revision 87cc73a1ade6168487d1841f4c285fadcf532e0c)
+++ src/sas/qtgui/DataExplorer.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
@@ -399,14 +399,15 @@
         new_plot = Plotter(self)
 
-        def addDataPlot2D(plot_set):
+        def addDataPlot2D(plot_set, item):
             plot2D = Plotter2D(self)
+            plot2D.item = item
             plot2D.plot(plot_set)
             self.plotAdd(plot2D)
 
-        for plot_set in plots:
+        for item, plot_set in plots:
             if isinstance(plot_set, Data1D):
                 new_plot.plot(plot_set)
             elif isinstance(plot_set, Data2D):
-                addDataPlot2D(plot_set)
+                addDataPlot2D(plot_set, item)
             else:
                 msg = "Incorrect data type passed to Plotting"
@@ -450,5 +451,5 @@
 
         # Add new data to the old plot, if data type is the same.
-        for plot_set in new_plots:
+        for _, plot_set in new_plots:
             if type(plot_set) is type(old_plot._data):
                 old_plot.data = plot_set
Index: src/sas/qtgui/GUITests.py
===================================================================
--- src/sas/qtgui/GUITests.py	(revision 092a3d9e371190b241becedfa1c1b6039185593a)
+++ src/sas/qtgui/GUITests.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
@@ -24,4 +24,6 @@
 from UnitTesting import PlotUtilitiesTest
 from UnitTesting import ColorMapTest
+from UnitTesting import BoxSumTest
+from UnitTesting import SlicerModelTest
 
 def suite():
@@ -50,4 +52,6 @@
         unittest.makeSuite(PlotUtilitiesTest.PlotUtilitiesTest, 'test'),
         unittest.makeSuite(ColorMapTest.ColorMapTest, 'test'),
+        unittest.makeSuite(BoxSumTest.BoxSumTest, 'test'),
+        unittest.makeSuite(SlicerModelTest.SlicerModelTest, 'test'),
     )
     return unittest.TestSuite(suites)
Index: src/sas/qtgui/GuiUtils.py
===================================================================
--- src/sas/qtgui/GuiUtils.py	(revision a66ff28037574eadcde466c7b04da5c45b314939)
+++ src/sas/qtgui/GuiUtils.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
@@ -242,4 +242,14 @@
     assert isinstance(item, QtGui.QStandardItem)
     assert isinstance(update_data, QtCore.QVariant)
+    py_update_data = update_data.toPyObject()
+
+    # Check if data with the same ID is already present
+    for index in range(item.rowCount()):
+        plot_item = item.child(index)
+        if plot_item.isCheckable():
+            plot_data = plot_item.child(0).data().toPyObject()
+            if plot_data.id == py_update_data.id:
+                item.removeRow(index)
+                break
 
     checkbox_item = QtGui.QStandardItem(True)
@@ -249,5 +259,4 @@
 
     # Add "Info" item
-    py_update_data = update_data.toPyObject()
     if isinstance(py_update_data, (Data1D or Data2D)):
         # If Data1/2D added - extract Info from it
@@ -298,5 +307,5 @@
         if item.isCheckable() and item.checkState() == QtCore.Qt.Checked:
             # TODO: assure item type is correct (either data1/2D or Plotter)
-            plot_data.append(item.child(0).data().toPyObject())
+            plot_data.append((item, item.child(0).data().toPyObject()))
         # Going 1 level deeper only
         for index_2 in range(item.rowCount()):
@@ -304,5 +313,5 @@
             if item_2 and item_2.isCheckable() and item_2.checkState() == QtCore.Qt.Checked:
                 # TODO: assure item type is correct (either data1/2D or Plotter)
-                plot_data.append(item_2.child(0).data().toPyObject())
+                plot_data.append((item_2, item_2.child(0).data().toPyObject()))
 
     return plot_data
Index: src/sas/qtgui/Plotter.py
===================================================================
--- src/sas/qtgui/Plotter.py	(revision 092a3d9e371190b241becedfa1c1b6039185593a)
+++ src/sas/qtgui/Plotter.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
@@ -516,4 +516,169 @@
         self.plot(data=self.fit_result, marker='-', hide_error=True)
 
+    def onMplMouseDown(self, event):
+        """
+        Left button down and ready to drag
+        """
+        # Check that the LEFT button was pressed
+        if event.button == 1:
+            self.leftdown = True
+            ax = event.inaxes
+            for text in self.textList:
+                if text.contains(event)[0]: # If user has clicked on text
+                    self.selectedText = text
+                    return
+
+            if ax != None:
+                self.xInit, self.yInit = event.xdata, event.ydata
+                try:
+                    self.x_click = float(event.xdata)  # / size_x
+                    self.y_click = float(event.ydata)  # / size_y
+                except:
+                    self.position = None
+
+    def onMplMouseUp(self, event):
+        """
+        Set the data coordinates of the click
+        """
+        self.x_click = event.xdata
+        self.y_click = event.ydata
+
+        # Check that the LEFT button was released
+        if event.button == 1:
+            self.leftdown = False
+            #self.leftup = True
+            self.selectedText = None
+
+        #release the legend
+        if self.gotLegend == 1:
+            self.gotLegend = 0
+
+    def onMplMouseMotion(self, event):
+        """
+        Check if the left button is press and the mouse in moving.
+        Compute delta for x and y coordinates and then perform the drag
+        """
+        if self.gotLegend == 1 and self.leftdown:
+            self.onLegendMotion(event)
+            return
+
+        if self.leftdown and self.selectedText is not None:
+            # User has clicked on text and is dragging
+            ax = event.inaxes
+            if ax != None:
+                # Only move text if mouse is within axes
+                self.selectedText.set_position((event.xdata, event.ydata))
+                self.canvas.draw_idle()
+            else:
+                # User has dragged outside of axes
+                self.selectedText = None
+            return
+
+    def onMplPick(self, event):
+        """
+        On pick legend
+        """
+        legend = self.legend
+        if event.artist == legend:
+            # Get the box of the legend.
+            bbox = self.legend.get_window_extent()
+            # Get mouse coordinates at time of pick.
+            self.mouse_x = event.mouseevent.x
+            self.mouse_y = event.mouseevent.y
+            # Get legend coordinates at time of pick.
+            self.legend_x = bbox.xmin
+            self.legend_y = bbox.ymin
+            # Indicate we picked up the legend.
+            self.gotLegend = 1
+
+            #self.legend.legendPatch.set_alpha(0.5)
+
+    def onLegendMotion(self, event):
+        """
+        On legend in motion
+        """
+        ax = event.inaxes
+        if ax == None:
+            return
+        # Event occurred inside a plotting area
+        lo_x, hi_x = ax.get_xlim()
+        lo_y, hi_y = ax.get_ylim()
+        # How much the mouse moved.
+        x = mouse_diff_x = self.mouse_x - event.x
+        y = mouse_diff_y = self.mouse_y - event.y
+        # Put back inside
+        if x < lo_x:
+            x = lo_x
+        if x > hi_x:
+            x = hi_x
+        if y < lo_y:
+            y = lo_y
+        if y > hi_y:
+            y = hi_y
+        # Move the legend from its previous location by that same amount
+        loc_in_canvas = self.legend_x - mouse_diff_x, \
+                        self.legend_y - mouse_diff_y
+        # Transform into legend coordinate system
+        trans_axes = self.legend.parent.transAxes.inverted()
+        loc_in_norm_axes = trans_axes.transform_point(loc_in_canvas)
+        self.legend_pos_loc = tuple(loc_in_norm_axes)
+        self.legend._loc = self.legend_pos_loc
+        # self.canvas.draw()
+        self.canvas.draw_idle()
+
+    def onMplWheel(self, event):
+        """
+        Process mouse wheel as zoom events
+        """
+        ax = event.inaxes
+        step = event.step
+
+        if ax != None:
+            # Event occurred inside a plotting area
+            lo, hi = ax.get_xlim()
+            lo, hi = PlotUtilities.rescale(lo, hi, step,
+                              pt=event.xdata, scale=ax.get_xscale())
+            if not self.xscale == 'log' or lo > 0:
+                self._scale_xlo = lo
+                self._scale_xhi = hi
+                ax.set_xlim((lo, hi))
+
+            lo, hi = ax.get_ylim()
+            lo, hi = PlotUtilities.rescale(lo, hi, step, pt=event.ydata,
+                              scale=ax.get_yscale())
+            if not self.yscale == 'log' or lo > 0:
+                self._scale_ylo = lo
+                self._scale_yhi = hi
+                ax.set_ylim((lo, hi))
+        else:
+            # Check if zoom happens in the axes
+            xdata, ydata = None, None
+            x, y = event.x, event.y
+
+            for ax in self.axes:
+                insidex, _ = ax.xaxis.contains(event)
+                if insidex:
+                    xdata, _ = ax.transAxes.inverted().transform_point((x, y))
+                insidey, _ = ax.yaxis.contains(event)
+                if insidey:
+                    _, ydata = ax.transAxes.inverted().transform_point((x, y))
+            if xdata is not None:
+                lo, hi = ax.get_xlim()
+                lo, hi = PlotUtilities.rescale(lo, hi, step,
+                                  bal=xdata, scale=ax.get_xscale())
+                if not self.xscale == 'log' or lo > 0:
+                    self._scale_xlo = lo
+                    self._scale_xhi = hi
+                    ax.set_xlim((lo, hi))
+            if ydata is not None:
+                lo, hi = ax.get_ylim()
+                lo, hi = PlotUtilities.rescale(lo, hi, step, bal=ydata,
+                                  scale=ax.get_yscale())
+                if not self.yscale == 'log' or lo > 0:
+                    self._scale_ylo = lo
+                    self._scale_yhi = hi
+                    ax.set_ylim((lo, hi))
+        self.canvas.draw_idle()
+
 
 class Plotter(QtGui.QDialog, PlotterWidget):
Index: src/sas/qtgui/Plotter2D.py
===================================================================
--- src/sas/qtgui/Plotter2D.py	(revision 5d89f43266c67cb96a7bf395800ce4cce896c9f8)
+++ src/sas/qtgui/Plotter2D.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
@@ -11,10 +11,22 @@
 
 import sas.qtgui.PlotUtilities as PlotUtilities
+import sas.qtgui.GuiUtils as GuiUtils
 from sas.qtgui.PlotterBase import PlotterBase
 from sas.qtgui.ColorMap import ColorMap
+from sas.sasgui.guiframe.dataFitting import Data1D
 from sas.sasgui.guiframe.dataFitting import Data2D
+from sas.sascalc.dataloader.manipulations import CircularAverage
+from sas.sasgui.guiframe.local_perspectives.plotting.binder import BindArtist
+from sas.qtgui.BoxSum import BoxSum
+from sas.qtgui.GuiUtils import formatNumber
+from sas.qtgui.SlicerParameters import SlicerParameters
+from sas.sasgui.guiframe.local_perspectives.plotting.boxSlicer import BoxInteractorX
+from sas.sasgui.guiframe.local_perspectives.plotting.AnnulusSlicer import AnnulusInteractor
+from sas.sasgui.guiframe.local_perspectives.plotting.SectorSlicer import SectorInteractor
+from sas.sasgui.guiframe.local_perspectives.plotting.boxSum import BoxSumCalculator
+from sas.sasgui.guiframe.local_perspectives.plotting.boxSlicer import BoxInteractorY
 
 # Minimum value of Z for which we will present data.
-MIN_Z=-32
+MIN_Z = -32
 
 class Plotter2DWidget(PlotterBase):
@@ -29,4 +41,10 @@
         # Default scale
         self.scale = 'log_{10}'
+        # to set the order of lines drawn first.
+        self.slicer_z = 5
+        # Reference to the current slicer
+        self.slicer = None
+        # Create Artist and bind it
+        self.connect = BindArtist(self.figure)
         self.vmin = None
         self.vmax = None
@@ -53,5 +71,15 @@
         self.title(title=data.title)
 
-    def plot(self, data=None, marker=None, linestyle=None):
+    @property
+    def item(self):
+        ''' getter for this plot's QStandardItem '''
+        return self._item
+
+    @item.setter
+    def item(self, item=None):
+        ''' setter for this plot's QStandardItem '''
+        self._item = item
+
+    def plot(self, data=None):
         """
         Plot 2D self._data
@@ -61,5 +89,5 @@
             self.data = data
 
-        assert(self._data)
+        assert self._data
 
         # Toggle the scale
@@ -128,7 +156,10 @@
         self.actionBoxAveragingY = self.contextMenu.addAction("&Box Averaging in Qy")
         self.actionBoxAveragingY.triggered.connect(self.onBoxAveragingY)
-        self.contextMenu.addSeparator()
-        self.actionEditGraphLabel = self.contextMenu.addAction("&Edit Graph Label")
-        self.actionEditGraphLabel.triggered.connect(self.onEditgraphLabel)
+        # Additional items for slicer interaction
+        if self.slicer:
+            self.actionClearSlicer = self.contextMenu.addAction("&Clear Slicer")
+            self.actionClearSlicer.triggered.connect(self.onClearSlicer)
+            self.actionEditSlicer = self.contextMenu.addAction("&Edit Slicer Parameters")
+            self.actionEditSlicer.triggered.connect(self.onEditSlicer)
         self.contextMenu.addSeparator()
         self.actionColorMap = self.contextMenu.addAction("&2D Color Map")
@@ -166,38 +197,133 @@
         self.plot()
 
+    def onClearSlicer(self):
+        """
+        Remove all sclicers from the chart
+        """
+        if self.slicer:
+            self.slicer.clear()
+            self.canvas.draw()
+            self.slicer = None
+
+    def onEditSlicer(self):
+        """
+        Present a small dialog for manipulating the current slicer
+        """
+        assert self.slicer
+
+        self.param_model = self.slicer.model()
+         # Pass the model to the Slicer Parameters widget
+        self.slicer_widget = SlicerParameters(self, model=self.param_model)
+        self.slicer_widget.show()
+
     def onCircularAverage(self):
         """
-        """
-        pass
+        Perform circular averaging on Data2D
+        """
+        # Find the best number of bins
+        npt = numpy.sqrt(len(self.data.data[numpy.isfinite(self.data.data)]))
+        npt = numpy.floor(npt)
+        # compute the maximum radius of data2D
+        self.qmax = max(numpy.fabs(self.data.xmax),
+                        numpy.fabs(self.data.xmin))
+        self.ymax = max(numpy.fabs(self.data.ymax),
+                        numpy.fabs(self.data.ymin))
+        self.radius = numpy.sqrt(numpy.power(self.qmax, 2) + numpy.power(self.ymax, 2))
+        #Compute beam width
+        bin_width = (self.qmax + self.qmax) / npt
+        # Create data1D circular average of data2D
+        circle = CircularAverage(r_min=0, r_max=self.radius, bin_width=bin_width)
+        circ = circle(self.data)
+        dxl = circ.dxl if hasattr(circ, "dxl") else None
+        dxw = circ.dxw if hasattr(circ, "dxw") else None
+
+        new_plot = Data1D(x=circ.x, y=circ.y, dy=circ.dy, dx=circ.dx)
+        new_plot.dxl = dxl
+        new_plot.dxw = dxw
+        new_plot.name = new_plot.title = "Circ avg " + self.data.name
+        new_plot.source = self.data.source
+        new_plot.interactive = True
+        new_plot.detector = self.data.detector
+
+        # Define axes if not done yet.
+        new_plot.xaxis("\\rm{Q}", "A^{-1}")
+        if hasattr(self.data, "scale") and \
+                    self.data.scale == 'linear':
+            new_plot.ytransform = 'y'
+            new_plot.yaxis("\\rm{Residuals} ", "normalized")
+        else:
+            new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
+
+        new_plot.group_id = "2daverage" + self.data.name
+        new_plot.id = "Circ avg " + self.data.name
+        new_plot.is_data = True
+        variant_plot = QtCore.QVariant(new_plot)
+        GuiUtils.updateModelItemWithPlot(self._item, variant_plot, new_plot.id)
+        # TODO: force immediate display (?)
+
+    def setSlicer(self, slicer):
+        """
+        Clear the previous slicer and create a new one.
+        slicer: slicer class to create
+        """
+        # Clear current slicer
+        if self.slicer is not None:
+            self.slicer.clear()
+        # Create a new slicer
+        self.slicer_z += 1
+        self.slicer = slicer(self, self.ax, item=self._item, zorder=self.slicer_z)
+        self.ax.set_ylim(self.data.ymin, self.data.ymax)
+        self.ax.set_xlim(self.data.xmin, self.data.xmax)
+        # Draw slicer
+        self.figure.canvas.draw()
+        self.slicer.update()
 
     def onSectorView(self):
         """
-        """
-        pass
+        Perform sector averaging on Q and draw sector slicer
+        """
+        self.setSlicer(slicer=SectorInteractor)
 
     def onAnnulusView(self):
         """
-        """
-        pass
+        Perform sector averaging on Phi and draw annulus slicer
+        """
+        self.setSlicer(slicer=AnnulusInteractor)
 
     def onBoxSum(self):
         """
-        """
-        pass
+        Perform 2D Data averaging Qx and Qy.
+        Display box slicer details.
+        """
+        self.onClearSlicer()
+        self.slicer_z += 1
+        self.slicer = BoxSumCalculator(self, self.ax, zorder=self.slicer_z)
+
+        self.ax.set_ylim(self.data.ymin, self.data.ymax)
+        self.ax.set_xlim(self.data.xmin, self.data.xmax)
+        self.figure.canvas.draw()
+        self.slicer.update()
+
+        # Get the BoxSumCalculator model.
+        self.box_sum_model = self.slicer.model()
+        # Pass the BoxSumCalculator model to the BoxSum widget
+        self.boxwidget = BoxSum(self, model=self.box_sum_model)
+        # Add the plot to the workspace
+        self.manager.parent.workspace().addWindow(self.boxwidget)
+        self.boxwidget.show()
 
     def onBoxAveragingX(self):
         """
-        """
-        pass
+        Perform 2D data averaging on Qx
+        Create a new slicer.
+        """
+        self.setSlicer(slicer=BoxInteractorX)
 
     def onBoxAveragingY(self):
         """
-        """
-        pass
-
-    def onEditgraphLabel(self):
-        """
-        """
-        pass
+        Perform 2D data averaging on Qy
+        Create a new slicer .
+        """
+        self.setSlicer(slicer=BoxInteractorY)
 
     def onColorMap(self):
@@ -225,6 +351,5 @@
 
     def showPlot(self, data, qx_data, qy_data, xmin, xmax, ymin, ymax,
-                 zmin, zmax, color=0, symbol=0, markersize=0,
-                 label='data2D', cmap=DEFAULT_CMAP):
+                 zmin, zmax, label='data2D', cmap=DEFAULT_CMAP):
         """
         Render and show the current data
@@ -310,7 +435,6 @@
             self.figure.subplots_adjust(left=0.1, right=.8, bottom=.1)
 
-            X = self._data.x_bins[0:-1]
-            Y = self._data.y_bins[0:-1]
-            X, Y = numpy.meshgrid(X, Y)
+            data_x, data_y = numpy.meshgrid(self._data.x_bins[0:-1],
+                                            self._data.y_bins[0:-1])
 
             ax = Axes3D(self.figure)
@@ -319,9 +443,10 @@
             # TODO: Define "large" for a dataset
             SET_TOO_LARGE = 500
-            if len(X) > SET_TOO_LARGE:
+            if len(data_x) > SET_TOO_LARGE:
                 ax.disable_mouse_rotation()
 
             self.figure.canvas.resizing = False
-            im = ax.plot_surface(X, Y, output, rstride=1, cstride=1, cmap=cmap,
+            im = ax.plot_surface(data_x, data_y, output, rstride=1,
+                                 cstride=1, cmap=cmap,
                                  linewidth=0, antialiased=False)
             self.ax.set_axis_off()
@@ -332,7 +457,16 @@
             self.figure.canvas.draw()
 
+    def update(self):
+        self.figure.canvas.draw()
+
+    def draw(self):
+        self.figure.canvas.draw()
+
+
 class Plotter2D(QtGui.QDialog, Plotter2DWidget):
+    """
+    Plotter widget implementation
+    """
     def __init__(self, parent=None, quickplot=False, dimension=2):
-
         QtGui.QDialog.__init__(self)
         Plotter2DWidget.__init__(self, manager=parent, quickplot=quickplot, dimension=dimension)
Index: src/sas/qtgui/PlotterBase.py
===================================================================
--- src/sas/qtgui/PlotterBase.py	(revision 092a3d9e371190b241becedfa1c1b6039185593a)
+++ src/sas/qtgui/PlotterBase.py	(revision 3bdbfcc5cdff8a3a11a9bb19c1cc8c3660a9c2e2)
@@ -220,168 +220,33 @@
         self.contextMenu.exec_(self.canvas.mapToGlobal(event_pos))
 
+    def onMplMouseUp(self, event):
+        """
+        Mouse button up callback
+        """
+        pass
+
     def onMplMouseDown(self, event):
         """
-        Left button down and ready to drag
-        """
-        # Check that the LEFT button was pressed
-        if event.button == 1:
-            self.leftdown = True
-            ax = event.inaxes
-            for text in self.textList:
-                if text.contains(event)[0]: # If user has clicked on text
-                    self.selectedText = text
-                    return
-
-            if ax != None:
-                self.xInit, self.yInit = event.xdata, event.ydata
-                try:
-                    self.x_click = float(event.xdata)  # / size_x
-                    self.y_click = float(event.ydata)  # / size_y
-                except:
-                    self.position = None
-
-    def onMplMouseUp(self, event):
-        """
-        Set the data coordinates of the click
-        """
-        self.x_click = event.xdata
-        self.y_click = event.ydata
-
-        # Check that the LEFT button was released
-        if event.button == 1:
-            self.leftdown = False
-            #self.leftup = True
-            self.selectedText = None
-
-        #release the legend
-        if self.gotLegend == 1:
-            self.gotLegend = 0
+        Mouse button down callback
+        """
+        pass
 
     def onMplMouseMotion(self, event):
         """
-        Check if the left button is press and the mouse in moving.
-        Compute delta for x and y coordinates and then perform the drag
-        """
-        if self.gotLegend == 1 and self.leftdown:
-            self.onLegendMotion(event)
-            return
-
-        if self.leftdown and self.selectedText is not None:
-            # User has clicked on text and is dragging
-            ax = event.inaxes
-            if ax != None:
-                # Only move text if mouse is within axes
-                self.selectedText.set_position((event.xdata, event.ydata))
-                self.canvas.draw_idle()
-            else:
-                # User has dragged outside of axes
-                self.selectedText = None
-            return
+        Mouse motion callback
+        """
+        pass
 
     def onMplPick(self, event):
         """
-        On pick legend
-        """
-        legend = self.legend
-        if event.artist == legend:
-            # Get the box of the legend.
-            bbox = self.legend.get_window_extent()
-            # Get mouse coordinates at time of pick.
-            self.mouse_x = event.mouseevent.x
-            self.mouse_y = event.mouseevent.y
-            # Get legend coordinates at time of pick.
-            self.legend_x = bbox.xmin
-            self.legend_y = bbox.ymin
-            # Indicate we picked up the legend.
-            self.gotLegend = 1
-
-            #self.legend.legendPatch.set_alpha(0.5)
-
-    def onLegendMotion(self, event):
-        """
-        On legend in motion
-        """
-        ax = event.inaxes
-        if ax == None:
-            return
-        # Event occurred inside a plotting area
-        lo_x, hi_x = ax.get_xlim()
-        lo_y, hi_y = ax.get_ylim()
-        # How much the mouse moved.
-        x = mouse_diff_x = self.mouse_x - event.x
-        y = mouse_diff_y = self.mouse_y - event.y
-        # Put back inside
-        if x < lo_x:
-            x = lo_x
-        if x > hi_x:
-            x = hi_x
-        if y < lo_y:
-            y = lo_y
-        if y > hi_y:
-            y = hi_y
-        # Move the legend from its previous location by that same amount
-        loc_in_canvas = self.legend_x - mouse_diff_x, \
-                        self.legend_y - mouse_diff_y
-        # Transform into legend coordinate system
-        trans_axes = self.legend.parent.transAxes.inverted()
-        loc_in_norm_axes = trans_axes.transform_point(loc_in_canvas)
-        self.legend_pos_loc = tuple(loc_in_norm_axes)
-        self.legend._loc = self.legend_pos_loc
-        # self.canvas.draw()
-        self.canvas.draw_idle()
+        Mouse pick callback
+        """
+        pass
 
     def onMplWheel(self, event):
         """
-        Process mouse wheel as zoom events
-        """
-        ax = event.inaxes
-        step = event.step
-
-        if ax != None:
-            # Event occurred inside a plotting area
-            lo, hi = ax.get_xlim()
-            lo, hi = PlotUtilities.rescale(lo, hi, step,
-                              pt=event.xdata, scale=ax.get_xscale())
-            if not self.xscale == 'log' or lo > 0:
-                self._scale_xlo = lo
-                self._scale_xhi = hi
-                ax.set_xlim((lo, hi))
-
-            lo, hi = ax.get_ylim()
-            lo, hi = PlotUtilities.rescale(lo, hi, step, pt=event.ydata,
-                              scale=ax.get_yscale())
-            if not self.yscale == 'log' or lo > 0:
-                self._scale_ylo = lo
-                self._scale_yhi = hi
-                ax.set_ylim((lo, hi))
-        else:
-            # Check if zoom happens in the axes
-            xdata, ydata = None, None
-            x, y = event.x, event.y
-
-            for ax in self.axes:
-                insidex, _ = ax.xaxis.contains(event)
-                if insidex:
-                    xdata, _ = ax.transAxes.inverted().transform_point((x, y))
-                insidey, _ = ax.yaxis.contains(event)
-                if insidey:
-                    _, ydata = ax.transAxes.inverted().transform_point((x, y))
-            if xdata is not None:
-                lo, hi = ax.get_xlim()
-                lo, hi = PlotUtilities.rescale(lo, hi, step,
-                                  bal=xdata, scale=ax.get_xscale())
-                if not self.xscale == 'log' or lo > 0:
-                    self._scale_xlo = lo
-                    self._scale_xhi = hi
-                    ax.set_xlim((lo, hi))
-            if ydata is not None:
-                lo, hi = ax.get_ylim()
-                lo, hi = PlotUtilities.rescale(lo, hi, step, bal=ydata,
-                                  scale=ax.get_yscale())
-                if not self.yscale == 'log' or lo > 0:
-                    self._scale_ylo = lo
-                    self._scale_yhi = hi
-                    ax.set_ylim((lo, hi))
-        self.canvas.draw_idle()
+        Mouse wheel scroll callback
+        """
+        pass
 
     def clean(self):
